'--- Set the path according to your system of folders
%path = "c:\mpa\W7"
%starthist = "1996:1"
%endhist = "2010:1"

cd {%path}

'----- Workfile ----
open kalman

'----- HP filter, serves for setting of initial conditions
'graph output_hp lgdp lgdp_tnd_hp
'show output_hp

'----- KALMAN FILTER -----
'--- Follow data (HP filter and inflation) and set initial conditions for state variables
'--- Be aware that inflation is signal as well as state variable here
'--- Ordering: inflation, GDP trend, GDP gap (according to the ordering of state equations)
vector(3) m_prior
m_prior.fill 10, 1315, 0

'--- Set covariances for initial conditions
sym(3,3) v_prior
v_prior.fill 2, 0, 0, 3, 0, 3

'--- Creates state-space object named 'kalman'
sspace kalman

'--- Adds signal equation to the state-space object
kalman.append @signal dl_cpi = dl_cpi_x 'This is just a trick to make inflation a state-variable
kalman.append @signal lgdp = lgdp_tnd + lgdp_gap

'--- Adds state equations to the state-space object
kalman.append @state dl_cpi_x = 0.5*dl_cpi_x(-1) + (1-0.5)*dl_cpi_tar + x*lgdp_gap(-1) + [var = z] 
kalman.append @state lgdp_tnd = lgdp_tnd(-1) + x/4 + [var = z]
kalman.append @state lgdp_gap =  x*lgdp_gap(-1) + [var = z]

'--- Adds initial conditions and their covariances
kalman.append @mprior m_prior
kalman.append @vprior v_prior

'--- Constructs the maximum-likelihood function
kalman.ml

'--- Estimates state variables (smoothed)
kalman.makestates(t=smooth) *_k
rename *_k *

'----- Graphs -----
graph output lgdp lgdp_tnd
graph gap lgdp_gap_hp lgdp_gap
show output gap
